----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:20:35 10/07/2011 
-- Design Name: 
-- Module Name:    main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library eds_lib;
use eds_lib.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;



entity main is
	

    Port ( clk, reset : in  STD_LOGIC;
           siggen : out  STD_LOGIC_VECTOR (47 downto 0);
			  
			  sx2_ifclk			: out		std_logic;
			sx2_int				: in		std_logic;
			--sx2_ready			: in		std_logic;
			sx2_reset			: out		std_logic;
			sx2_sloe				: out		std_logic;
			sx2_slrd				: out		std_logic;
			sx2_slwr				: out		std_logic;
			sx2_pkt_end			: out		std_logic;
			sx2_fifo_address	: out		std_logic_vector(2 downto 0);
			--sx2_flag_a			: in		std_logic;
			--sx2_flag_b			: in		std_logic;
			--sx2_flag_c			: in		std_logic;
			sx2_wakeup			: out		std_logic;
			sx2_n_cs				: out		std_logic
			--sx2_fifo_data		: inout	std_logic_vector(15 downto 0);
			--usb_nc				: in		std_logic	
			  
			  
			  
			  );
end main;


architecture Behavioral of main is

	constant CLK_DIV_WIDTH : integer := 9;
	constant TEST_WIDTH : integer := 48;
	
	signal not_reset : std_logic;
	
	signal clk_div_tick : std_logic;
	signal clkdiv_qout : STD_LOGIC_VECTOR (CLK_DIV_WIDTH -1 downto 0);
	
	signal shift_reg, shift_next: STD_LOGIC_VECTOR (TEST_WIDTH -1 downto 0) := "100000000000000000000000000000000000000000000000";


begin

not_reset <= not reset;


-- divide clock
clk_divider : entity eds_lib.modm_counter
		--generic map (N => 20, M => 5)
		generic map (N => CLK_DIV_WIDTH, M => 2**CLK_DIV_WIDTH -1) -- quick simulation version
		port map (clk=>clk, reset=>not_reset , max_tick => clk_div_tick, q=>clkdiv_qout);
		
-- barrel shifter mem
process (clk, reset)
begin
	if (not_reset ='1') then
		shift_reg(TEST_WIDTH -1 downto 0)  <= "100000000000000000000000000000000000000000000000";
	elsif (clk'event and clk='1') then
		shift_reg <= shift_next;
	end if;
end process;

shift_next(0) <= shift_reg(TEST_WIDTH -1) when clk_div_tick='1' else shift_reg(0);
shift_next(TEST_WIDTH -1 downto 1) <=  shift_reg(TEST_WIDTH -2 downto 0) when clk_div_tick='1' else shift_reg(TEST_WIDTH -1 downto 1);

siggen <= shift_reg when clkdiv_qout(CLK_DIV_WIDTH-1) = '1' else (others=>'0');

sx2_ifclk <= '0';
sx2_reset			<= '0';
			sx2_sloe				<= '0';
			sx2_slrd				<= '0';
			sx2_slwr				<= '0';
			sx2_pkt_end			<= '0';
			sx2_fifo_address	<= (others=>'0');
			sx2_wakeup			<= '0';
			sx2_n_cs				<= '0';
			--sx2_fifo_data		: inout	std_logic_vector(15 downto 0);
			
end Behavioral;

